routes/web.php
    Route::post('login', [App\Http\Controllers\Admin\AuthController::class, 'login'])->name('signin');

});



// Authenticated users
Route::middleware(['auth','PreventBackHistory'])->group(function()
{

    // Auth Routes
    Route::get('edit-profile', [App\Http\Controllers\Admin\DashboardController::class, 'editProfile'] )->name('edit-profile');
    Route::get('home', fn () => redirect()->route('dashboard'))->name('home');
    Route::post('logout', [App\Http\Controllers\Admin\AuthController::class, 'Logout'])->name('logout');
    Route::get('show-change-password', [App\Http\Controllers\Admin\AuthController::class, 'showChangePassword'] )->name('show-change-password');
    Route::post('change-password', [App\Http\Controllers\Admin\AuthController::class, 'changePassword'] )->name('change-password');



    // Dashboard routes
    Route::get('dashboard', [App\Http\Controllers\Admin\DashboardController::class, 'index'])->name('dashboard');



    // Manual Sync Attendance
    Route::get('manual-sync', [App\Http\Controllers\Admin\MaualSyncController ::class, 'index'] )->name('manual-sync.index');
    Route::post('manual-sync', [App\Http\Controllers\Admin\MaualSyncController::class, 'addManualSync'] )->name('manual-sync.store');
    Route::post('check-sync-status', [App\Http\Controllers\Admin\MaualSyncController::class, 'checkSyncStatus'] )->name('check-sync-status');



    // Masters routes
    Route::resource('departments', App\Http\Controllers\Admin\Masters\DepartmentController::class );
    Route::get('departments/{department}/sub_departments', [App\Http\Controllers\Admin\Masters\DepartmentController::class, 'getSubDepartments'] )->name('departments.sub_departments');
    Route::resource('sub-departments', App\Http\Controllers\Admin\Masters\SubDepartmentController::class );
    Route::resource('wards', App\Http\Controllers\Admin\Masters\WardController::class );
    Route::get('wards/{ward}/departments', [App\Http\Controllers\Admin\Masters\DepartmentController::class, 'getWardDepartments'] )->name('wards.departments');
    Route::resource('clas', App\Http\Controllers\Admin\Masters\ClasController::class );
    Route::resource('designations', App\Http\Controllers\Admin\Masters\DesignationController::class );
    Route::resource('holidays', App\Http\Controllers\Admin\Masters\HolidayController::class );
    Route::resource('leave_types', App\Http\Controllers\Admin\Masters\LeaveTypeController::class );
    Route::resource('leaves', App\Http\Controllers\Admin\Masters\LeaveController::class );
    Route::resource('shifts', App\Http\Controllers\Admin\Masters\ShiftController::class );
    Route::resource('devices', App\Http\Controllers\Admin\Masters\DeviceController::class );


    // Users Roles n Permissions
    Route::resource('users', App\Http\Controllers\Admin\UserController::class );
    Route::get('users/{user}/toggle', [App\Http\Controllers\Admin\UserController::class, 'toggle' ])->name('users.toggle');
    Route::put('users/{user}/change-password', [App\Http\Controllers\Admin\UserController::class, 'changePassword' ])->name('users.change-password');
    Route::get('users/{user}/get-role', [App\Http\Controllers\Admin\UserController::class, 'getRole' ])->name('users.get-role');
    Route::put('users/{user}/assign-role', [App\Http\Controllers\Admin\UserController::class, 'assignRole' ])->name('users.assign-role');
    Route::resource('roles', App\Http\Controllers\Admin\RoleController::class );


    // Employees Routes
    Route::resource('employees', App\Http\Controllers\Admin\EmployeeController::class );
    Route::get('employees/{employee:emp_code}/info', [App\Http\Controllers\Admin\EmployeeController::class, 'fetchInfo'] )->name('employees.info');


    // Punches Routes
    Route::resource('punches', App\Http\Controllers\Admin\PunchController::class );
    Route::get('punches/{punch}/toggle', [App\Http\Controllers\Admin\PunchController::class, 'toggle' ])->name('punches.toggle');


    // Leaves Routes
    Route::resource('leave-requests', App\Http\Controllers\Admin\LeaveRequestController::class );
    Route::put('leave-requests/{leave_request}/change-request', [App\Http\Controllers\Admin\LeaveRequestController::class, 'changeRequest'] )->name('leave-requests.change-request');
    Route::get('active-medical-leave-requests', [App\Http\Controllers\Admin\LeaveRequestController::class, 'activeMedicalLeaveRequest'] )->name('leave-requests.active-medical-leave');
    Route::get('completed-medical-leave-requests', [App\Http\Controllers\Admin\LeaveRequestController::class, 'completedMedicalLeaveRequest'] )->name('leave-requests.completed-medical-leave');
    Route::get('leave-applications', [App\Http\Controllers\Admin\LeaveRequestController::class, 'pendingLeaveRequest'] )->name('leave-requests.application');


    // Employee Shifts
    Route::resource('rosters', App\Http\Controllers\Admin\RosterController::class );
    Route::get('sample_roster', [App\Http\Controllers\Admin\RosterController::class, 'downloadSample'] )->name('rosters.sample');
    Route::post('import_shift_roster', [App\Http\Controllers\Admin\RosterController::class, 'importShiftRoster'] )->name('rosters.import');


    // Reports
    Route::resource('reports', App\Http\Controllers\Admin\ReportController::class );
    Route::get('muster-report', [App\Http\Controllers\Admin\ReportController::class, 'musterReport'] )->name('reports.muster');
    Route::get('reports/get/month-wise-date', [App\Http\Controllers\Admin\ReportController::class, 'monthWiseDate'] )->name('reports.dates');
    Route::get('device_log_report', [App\Http\Controllers\Admin\ReportController::class, 'deviceLogReport'])->name('dashboard.device-log-report');
    Route::get('daily_attendance_report', [App\Http\Controllers\Admin\ReportController::class, 'dailyAttendanceReport'])->name('dashboard.daily-attendance-report');
    Route::get('department_wise_report', [App\Http\Controllers\Admin\ReportController::class, 'departmentWiseReport'])->name('dashboard.department-wise-report');
    Route::get('todays_present_report', [App\Http\Controllers\Admin\ReportController::class, 'todaysPresentReport'])->name('dashboard.todays-present-report');
    Route::get('todays_absent_report', [App\Http\Controllers\Admin\ReportController::class, 'todaysAbsentReport'])->name('dashboard.todays-absent-report');
    Route::get('shift_wise_employee/{shift_id}', [App\Http\Controllers\Admin\ReportController::class, 'shiftWiseEmployees'])->name('dashboard.shift-wise-employee');
    Route::get('todays_leave_bifurcation', [App\Http\Controllers\Admin\ReportController::class, 'todaysLeaveBifurcation'])->name('dashboard.todays-leave-bifurcation');
    Route::get('month_wise_latemark', [App\Http\Controllers\Admin\ReportController::class, 'monthWiseLatemark'])->name('dashboard.month-wise-latemark');
    Route::get('month_wise_absent', [App\Http\Controllers\Admin\ReportController::class, 'monthWiseAbsent'])->name('dashboard.month-wise-absent');
    Route::get('employee_wise_report', [App\Http\Controllers\Admin\ReportController::class, 'employeeWiseReport'])->name('dashboard.employee-wise-report');


});




Route::prefix('employee')->name('employee.')->group(function(){

    // Guest employees
    Route::middleware(['employee.guest','PreventBackHistory'])->group(function()
    {
        Route::get('/', fn()=> redirect()->route('login', ['device_type'=> 'mobile']) )->name('login');
        Route::get('/register', [App\Http\Controllers\Employee\AuthController::class, 'showRegister'])->name('register');
        Route::post('/emp-info', [App\Http\Controllers\Employee\AuthController::class, 'searchEmployeeCode'])->name('emp-info');
        Route::post('/register', [App\Http\Controllers\Employee\AuthController::class, 'register'])->name('signup');
    });

    // Authenticated employees
    Route::middleware(['employee.auth','PreventBackHistory'])->group(function()
    {
        Route::get('/home', [App\Http\Controllers\Employee\HomeController::class, 'index'])->name('home');
        Route::post('/employee-logout', [App\Http\Controllers\Employee\HomeController::class, 'logout'])->name('logout');
        Route::get('/delete-account', [App\Http\Controllers\Employee\HomeController::class, 'deleteAccount'])->name('delete-account');

        Route::get('show-change-password', [App\Http\Controllers\Employee\HomeController::class, 'showChangePassword'] )->name('show-change-password');
        Route::post('change-password', [App\Http\Controllers\Employee\HomeController::class, 'changePassword'] )->name('change-password');
    });

});

Route::get('/privacy-policy', [App\Http\Controllers\Employee\HomeController::class, 'privacyPolicy'])->name('privacy-policy');






Route::get('/import-department', function(){
    Artisan::call('department:import');
    return dd(Artisan::output());
});
Route::get('/import-punches', function(){
    Artisan::call('punches:import');
    return dd(Artisan::output());
});
Route::get('/import-employees', function(){
    Artisan::call('employees:import');
    return dd(Artisan::output());
});

Route::get('/php', function(Request $request){
    // if( !auth()->check() )
    //     return 'Unauthorized request';

    Artisan::call($request->artisan);
    return dd(Artisan::output());
});


Route::get('/test-code', function(){
    // DB::table('punches')
    //     ->where('punch_by', '2')
    //     ->orderBy('id')
    //     ->groupBy('punch_date', 'emp_code')
    //     ->delete();

    return 'done';
});

Route::get('/remove-duplicate', function(){
    DB::table('punches as p1')
        ->where('punch_by', '2')
        ->join(DB::raw('
            (SELECT punch_date, emp_code, MIN(id) AS min_id
            FROM punches
            GROUP BY punch_date, emp_code
            HAVING COUNT(*) > 1
            ) as p2'), function ($join) {
                $join->on('p1.punch_date', '=', 'p2.punch_date')
                    ->on('p1.emp_code', '=', 'p2.emp_code')

app/Models/Employee.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Support\Facades\Auth;

class Employee extends BaseModel
{
    use HasFactory, SoftDeletes;

    protected $table = 'app_employees';
    protected $fillable = ['user_id', 'shift_id', 'ward_id', 'clas_id', 'designation_id', 'doj', 'is_ot', 'is_divyang', 'permanent_address', 'present_address'];


    public function user()
    {
        return $this->belongsTo(User::class);
    }

    public function shift()
    {
        return $this->belongsTo(Shift::class);
    }

    public function ward()
    {
        return $this->belongsTo(Ward::class);
    }

    public function clas()
    {
        return $this->belongsTo(Clas::class);
    }

    public function designation()
    {
        return $this->belongsTo(Designation::class);
    }




    public static function booted()
    {
        static::created(function (Employee $employee)
        {
            EmployeeWeekoff::create([
                'user_id' => $employee->user_id,
                'weekoff_1' => 'saturday',
                'weekoff_2' => 'sunday',
            ]);
        });
    }

}

app/Http/Controllers/Admin/EmployeeController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Admin\Controller;
use App\Http\Requests\Admin\StoreEmployeeRequest;
use App\Http\Requests\Admin\UpdateEmployeeRequest;
use App\Models\Clas;
use App\Models\Department;
use App\Models\Designation;
use App\Models\Device;
use App\Models\Shift;
use App\Models\User;
use App\Models\Ward;
use App\Repositories\EmployeeRepository;
use Exception;
use Illuminate\Support\Facades\Auth;


class EmployeeController extends Controller
{

    protected $employeeRepository;
    public function __construct()
    {
        $this->employeeRepository = new EmployeeRepository;
    }
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $departments = Department::whereDepartmentId(null)->where('tenant_id', auth()->user()->tenant_id)->orderBy('name')->get();
        return view('admin.employees')->with(['departments'=> $departments]);
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        $wards = Ward::where('tenant_id', auth()->user()->tenant_id)->latest()->get();
        $departments = Department::whereDepartmentId(null)->where('tenant_id', auth()->user()->tenant_id)->orderBy('name')->get();
        $designations = Designation::latest()->get();
        $clas = Clas::latest()->get();
        $shifts = Shift::latest()->get();
        $devices = Device::orderByDesc('DeviceId')->get();


        return view('admin.add-employees')->with(['wards'=> $wards, 'departments'=> $departments, 'designations'=> $designations, 'clas'=> $clas, 'shifts'=> $shifts, 'devices'=>$devices]);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(StoreEmployeeRequest $request)
    {
        try
        {
            $this->employeeRepository->store($request->validated());
            return response()->json(['success'=> 'Employee created successfully!']);
        }
        catch(Exception $e)
        {
            return $this->respondWithAjax($e, 'adding', 'Employee');
        }
    }

    /**
     * Display the specified resource.
     */
    public function show(User $employee)
    {
        return $this->employeeRepository->showEmployee($employee);
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(User $employee)
    {
        return $this->employeeRepository->editEmployee($employee);
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(UpdateEmployeeRequest $request, User $employee)
    {
        try
        {
            $input = $request->validated();
            if(User::where(['emp_code' => $input['emp_code']])->whereNot('id', $employee->id)->exists())
                return response()->json(['error2'=> 'Employee with the same employee code already exists!']);


            $this->employeeRepository->updateEmployee($input, $employee);
            return response()->json(['success'=> 'Employee updated successfully!']);
        }
        catch(Exception $e)
        {
            return $this->respondWithAjax($e, 'updating', 'Employee');
        }
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(string $id)
    {
        //
    }

    public function fetchInfo(User $employee)
    {
        $authUser = auth()->user();

        if( $authUser->hasRole(['Admin', 'Super Admin']) )
            return $employee->load(['ward', 'clas', 'department']);

        if( $authUser->department_id != $employee->department_id )
            return response()->json(['error2'=> 'Employee does not belongs to your department']);

        return $employee->load(['ward', 'clas', 'department']);
    }
}

resources/views/employee/home.blade.php
<x-frontend.mobile-layout>
    {{-- <x-slot name="title">{{ auth()->user()->tenant_name }} - Dashboard</x-slot> --}}


    <div class="page-body">
        <div class="container">
            {{-- <div class="card custom-card rounded" style="overflow: initial;">
                <div class="card-header">
                    <div class="d-flex justify-content-between">
                        <h6 class="card-header rounded bg-primary py-2 px-3 text-center">Employee Code : {{ Auth::user()->emp_code }}</h6>
                        <div class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-bs-toggle="dropdown" aria-expanded="false">
                            <img src="https://mdbcdn.b-cdn.net/img/new/avatars/2.webp" class="rounded-circle profile-image" height="20" alt="Profile" />
                            </a>
                            <ul class="dropdown-menu dropdown-menu-end" aria-labelledby="navbarDropdown">
                            <li><a class="dropdown-item" onclick="event.preventDefault(); document.getElementById('logout-form').submit();" href="{{ route('employee.logout') }}">Logout</a></li>
                            </ul>
                        </div>

                        <form id="logout-form" action="{{ route('employee.logout') }}" method="POST" class="d-none">
                            @csrf
                        </form>
                    </div>
                </div>
            </div> --}}

            <div class="row mt-2">
                <div class="col-6">
                    <div class="card custom-card rounded">
                        <h6 class="card-header rounded bg-primary py-2 px-3 text-center">Today's In</h6>
                        <div class="card-footer p-0">
                            <div class="col-12 py-2">
                                <h3 class="counter">{{ $data['todays_in_time'] }}</h3>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="col-6">
                    <div class="card custom-card rounded">
                        <h6 class="card-header rounded bg-primary py-2 px-3 text-center">Today's Out</h6>
                        <div class="card-footer p-0">
                            <div class="col-12 py-2">
                                <h3 class="counter">{{ $data['todays_out_time'] }}</h3>
                            </div>
                        </div>
                    </div>
                </div>
            </div>



            {{-- Monthly Attendance --}}
            <div class="row mt-1">
                <div class="col-12">
                    <div class="card custom-card rounded">
                        <h6 class="card-header rounded bg-primary py-2 px-3 text-center">Monthly Attendance</h6>
                        <div class="card-footer row p-0">
                            <div class="col-4 py-2">
                                <h6>PRESENT</h6>
                                <h3 class="counter">{{ $data['total_present'] }}</h3>
                            </div>
                            <div class="col-4 py-2">
                                <h6>ABSENT</h6>
                                <h3 class="counter">{{ $data['total_absent'] }}</h3>
                            </div>
                            <div class="col-4 py-2">
                                <h6>LEAVE</h6>
                                <h3 class="counter">{{ $data['total_leave'] }}</h3>
                            </div>
                        </div>
                    </div>
                </div>
            </div>





            {{-- Filter --}}
            <div class="row mt-1">
                <div class="col-12">
                    <div class="card custom-card rounded">
                        <form action="{{ route('employee.home') }}" method="GET">
                            <div class="card-body row py-0 px-2">
                                <div class="col-5 py-2">
                                    <label class="mb-1" for="month">Month </label>
                                        <select class="col-sm-12 form-control @error('month') is-invalid  @enderror" value="{{ old('month') }}" required name="month">
                                            <option value="">--Select Month--</option>
                                            <option value="1" {{ request()->month == 1 ? 'selected' : '' }}>January</option>
                                            <option value="2" {{ request()->month == 2 ? 'selected' : '' }}>February</option>
                                            <option value="3" {{ request()->month == 3 ? 'selected' : '' }}>March</option>
                                            <option value="4" {{ request()->month == 4 ? 'selected' : '' }}>April</option>
                                            <option value="5" {{ request()->month == 5 ? 'selected' : '' }}>May</option>
                                            <option value="6" {{ request()->month == 6 ? 'selected' : '' }}>June</option>
                                            <option value="7" {{ request()->month == 7 ? 'selected' : '' }}>July</option>
                                            <option value="8" {{ request()->month == 8 ? 'selected' : '' }}>August</option>
                                            <option value="9" {{ request()->month == 9 ? 'selected' : '' }}>September</option>
                                            <option value="10" {{ request()->month == 10 ? 'selected' : '' }}>October</option>
                                            <option value="11" {{ request()->month == 11 ? 'selected' : '' }}>November</option>
                                            <option value="12" {{ request()->month == 12 ? 'selected' : '' }}>December</option>
                                        </select>
                                        @error('month')
                                            <span class="invalid-feedback" role="alert">
                                                <strong>{{ $message }}</strong>
                                            </span>
                                        @enderror
                                </div>

                                <div class="col-5 py-2">
                                    <label class="mb-1" for="year">Year </label>
                                    <select class="col-sm-12 form-control @error('year') is-invalid  @enderror" value="{{ old('year') }}" required name="year">
                                        <option value="">--Select Year--</option>
                                        <option value="2022" {{ request()->year == 2022 ? 'selected' : '' }}>2022</option>
                                        <option value="2023" {{ request()->year == 2023 ? 'selected' : '' }}>2023</option>
                                        <option value="2024" {{ request()->year == 2024 ? 'selected' : '' }}>2024</option>
                                    </select>
                                    @error('year')
                                        <span class="invalid-feedback" role="alert">
                                            <strong>{{ $message }}</strong>
                                        </span>
                                    @enderror
                                </div>

                                <div class="col-2 pt-2">
                                    <button type="submit" class="btn btn-primary mt-4 px-2" ><i class="fa fa-search"></i></button>
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>





            {{-- TABLE --}}
            <div class="row mt-1">
                <div class="col-12 pb-5">
                    <div class="card rounded">
                        <div class="card-block row rounded">
                            <div class="col-12 ">
                                <div class="table-responsive rounded">
                                    <table class="table table-hover table-striped">
                                        <thead class="bg-primary">
                                            <tr>
                                                <th scope="col">Date</th>
                                                <th scope="col">In Time</th>
                                                <th scope="col">Out Time</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            @foreach ($data['attendance'] as $punch)
                                                <tr>
                                                    <td>{{ $punch['date'] }}</td>
                                                    <td>{{ $punch['check_in'] }}</td>
                                                    <td>{{ $punch['check_out'] }}</td>
                                                </tr>
                                            @endforeach
                                        </tbody>
                                    </table>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>



        </div>
    </div>

</x-frontend.mobile-layout>